
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;


// Komplettes Beispiel einer "Datenbank-Anwendung"


public class bsp02 extends JFrame {

    // globale Variable, damit kann man das Fenster schlieen
    // wichtig init mit null
   Window_Liste _ListenFrame=null;

  //Frame konstruieren
  public bsp02() {

    setSize(300, 100);
    setLocation(400,50);
    setTitle("Beispiel 02");

    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setGUI();
  } // create


  void setGUI() {
    JButton BnInput;		// Schalter definieren
    JButton BnListe;		// Schalter definieren
    JPanel box1;

      // South
		BnInput = new JButton();  	// Schalter erzeugen
		BnInput.setText("Eingabe");  	// Text setzen
    BnInput.setFont( new Font("Arial", Font.BOLD,28));
		BnListe= new JButton();  	// Schalter erzeugen
		BnListe.setText("Liste");  	// Text setzen
    BnListe.setFont( new Font("Arial", Font.BOLD,28));

    box1 = new JPanel();
    box1.setLayout( new FlowLayout() );
    box1.add(BnInput);
    box1.add(BnListe) ;
    this.getContentPane().add(box1, BorderLayout.NORTH);

    BnInput.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        BnInput_Click();
      }
    });
    BnListe.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        BnListe_Click();
      }
    });

  }  // setGUI

    // Methode erzeugt EIN Eingabefenster
  void BnInput_Click() {
    Window_Input frame;  // Definition
    frame = new Window_Input(); // Erzeugen
    frame.setVisible(true);  // Anzeigen
    System.out.println("Fenster Eingabe wurde erzeugt");
  }

  // Erzeugt eine Listenfenster (Editor)
  void BnListe_Click() {
      // Gibt es schon ein Listenfenster?
    if (_ListenFrame!=null) {
      _ListenFrame.dispose(); // lschen
    }
    _ListenFrame = new Window_Liste("Student.bin");
    _ListenFrame.setVisible(true);
    System.out.println("Window Liste wurde erzeugt");
  }



  public static void main(String[] args) {
    bsp02 frame = new bsp02();
    frame.setVisible(true);
  }


}  // bsp02


// Klasse
class Window_Input extends JFrame {
  final int left1 = 10;   // Anfangspos fr die JLabel
  final int left2 = 150;  // Anfangspos fr die Editor
  final int left3 = 560;  // Anfangspos fr den Schalter
  final int width1 = 130; // Breite der JLabel
  final int width2 = 400; // Breite der Editoren

  // Statische Variable, kommt nur EINMAL im System vor !!
  static long S_MatrNr = 9999;

    // Definition der GUI-Elemente
  JLabel      LVorname;
  JLabel      LNachname;
  JLabel      LMatrnr;
  JLabel      LStudiengang;
  JTextField  EVorname;
  JTextField  ENachname;
  JTextField  EMatrnr;

  JComboBox   CStudiengang;

  JButton BnCalcMatrnr;		// Schalter definieren
  JButton BnSave;
  JButton BnEsc;


    // "Globale" Variable der Datenbank
  Database _database;

  //Frame konstruieren
  public Window_Input() {
    setSize(700, 350);  // width height
    setLocation(10,200);  // x/y
    setTitle("Eingabe von Daten");
    this.getContentPane().setLayout( null );

    _database = new Database("Student.bin");

    // setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setGUI();
    readMatrNr();  // Einlesen der letzten Matrikelnummer
  } // create


  void setGUI() {
    LVorname = new JLabel("Vorname");
    LNachname = new JLabel("Nachname");
    LMatrnr  = new JLabel("Matrnr");
    EVorname = new JTextField("");
    ENachname = new JTextField("");
    EMatrnr = new JTextField("");
    LStudiengang = new JLabel("Studiengang");

    this.getContentPane().add(LVorname);
    LVorname.setBounds(left1, 10, width1, 40); // x/y   width height
    LVorname.setFont( new Font("Arial", Font.BOLD,20));

    this.getContentPane().add(EVorname);
    EVorname.setBounds(left2, 10, width2, 40); // x/y   width height
    EVorname.setFont( new Font("Arial", Font.BOLD,20));

    // -------------------

    this.getContentPane().add(LNachname);
    LNachname.setBounds(left1, 70, width1, 40); // x/y   width height
    LNachname.setFont( new Font("Arial", Font.BOLD,20));

    this.getContentPane().add(ENachname);
    ENachname.setBounds(left2, 70, width2, 40); // x/y   width height
    ENachname.setFont( new Font("Arial", Font.BOLD,20));
    // -------------------

    this.getContentPane().add(LMatrnr);
    LMatrnr.setBounds(left1, 130, width1, 40); // x/y   width height
    LMatrnr.setFont( new Font("Arial", Font.BOLD,20));

    this.getContentPane().add(EMatrnr);
    EMatrnr.setBounds(left2, 130, width2, 40); // x/y   width height
    EMatrnr.setFont( new Font("Arial", Font.BOLD,20));
    EMatrnr.setEditable(false);

    BnCalcMatrnr = new JButton("holen");
    BnCalcMatrnr.setFont( new Font("Arial", Font.BOLD,20));
      // Verknpfen des Schalters mit einer Methode 
    BnCalcMatrnr.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        BnCalcMatrnr_Click();
      }
    });
    this.getContentPane().add(BnCalcMatrnr);
    BnCalcMatrnr.setBounds(left3, 130, 100, 40); // x/y   width height

    // -------------------
    this.getContentPane().add(LStudiengang);
    LStudiengang.setBounds(left1, 180, width1, 40); // x/y   width height
    LStudiengang.setFont( new Font("Arial", Font.BOLD,20));

      // Erzeugen einer ComboBox
      // 1. Erzeugen eines Arrays (Alternativ mit einem Vector)
      // 2. Create
    String[] items;
    items = new String[6];
    items[0] = "Automatisierungstechnik";
    items[1] = "Informatik Bachelor";
    items[2] = "Intelligente Automatisierungssysteme";
    items[3] = "Ingenieurinformatik";
    items[4] = "Kommunikationsinformatik";
    items[5] = "Kommunikationstechnik";

    CStudiengang = new JComboBox(items);

    this.getContentPane().add(CStudiengang);
    CStudiengang.setBounds(left2, 180, width2, 40); // x/y   width height
    CStudiengang.setFont( new Font("Arial", Font.BOLD,24));

    // -------------------
    BnSave = new JButton("Speichern");
    BnSave.setFont( new Font("Arial", Font.BOLD,24));
    BnSave.setBounds(100, 250, 170, 40); // x/y   width height
    BnSave.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        BnSave_Click();
      }
    });
    this.getContentPane().add(BnSave);
    // -------------------
    BnEsc = new JButton("Abbruch");
    BnEsc.setFont( new Font("Arial", Font.BOLD,24));
    BnEsc.setBounds(300, 250, 170, 40); // x/y   width height
    BnEsc.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        BnEsc_Click();
      }
    });
    this.getContentPane().add(BnEsc);
  }  // setGUI


    // Einlesen der letzten Matriklenr
    // Vorher Check, ob Datei existiert
  private void readMatrNr() {
    FileInputStream Fin;
    DataInputStream Din;
    File file;
    try {
      file = new File("Matrnr.bin");  // Erzeugen eines FILES
      if (file.exists() ) {
        Fin = new FileInputStream("Matrnr.bin");
        Din = new MyDataInputStream(Fin);
        S_MatrNr = Din.readLong();
        Fin.close();
      }
    }
    catch (IOException e2) {
    }
  }  // readMatr

    // Schreiben der aktuellen Matrikelnr
  private void writeMatrNr() {
    FileOutputStream Fout;
    DataOutputStream Dout;
    try {
      Fout = new FileOutputStream("Matrnr.bin");
      Dout = new MyDataOutputStream(Fout);
      Dout.writeLong(S_MatrNr);
      Fout.close();
    }
    catch (IOException e2) {
    }
  } // writeMatrNr



    // setzt die aktuelle Matrikelnummer
    // hier wird NICHT hochgezaehlt
    // erst in BnSave_Click
  void BnCalcMatrnr_Click() {
    EMatrnr.setText( Long.toString(S_MatrNr+1) );
  }

    // Test, ob Eingabe in Matrikelnummer gueltig
    // wenn setEditable(false) gesetzt
    //   dann fast unnoetig 
  public long LVal(String sText) {
        long result =-999;
        try {
            result = Long.valueOf(sText).longValue();
        }
        catch (NumberFormatException e) {
          result = -999;
        }
        return result;
  } // LVal

    // soll den aktuellen Datensatz speichern
    // Aufruf der Methode addStudent
    // Besser waere eine Instanz der Klasse Student, aber zu frueh
  void BnSave_Click() {
    String sVorname, sNachname, sMatrNr, sStdgang;
    long Matrnr;
    sVorname = EVorname.getText();
    sNachname = ENachname.getText();
    sMatrNr = EMatrnr.getText();
    sStdgang = (String) CStudiengang.getSelectedItem();

    Matrnr = LVal(sMatrNr);
    if (Matrnr<0) {
      System.out.println("Fehlerhafte Eingabe");
      return;
    }

      // speichern der Daten in die Datenbank
    _database.addStudent(sVorname, sNachname, Matrnr, sStdgang);

    writeMatrNr();  // Speichern der letzten Matrikelnummer
    S_MatrNr++;  // nun erst erhoehen
      // loeschen der Daten
    EVorname.setText("");
    ENachname.setText("");
    EMatrnr.setText("");
      // setFocus()
    EVorname.requestFocus();  // setzt den Foucs auf das GUI-Element
    System.out.println("Save wurde gedrueckt");
  }

  void BnEsc_Click() {
    setTitle("Abbruch gedrueckt");
    this.dispose();
  }


}  // window_input


// Fenster zum Anzeigen aller vorhandenen Studenten
class Window_Liste extends JFrame {

  String _sFilename;
  JTextArea Editor;

  //Frame konstruieren
  public Window_Liste(String sFilename) {
    _sFilename = sFilename;

    setSize(600, 500);  // Width, Height
    setLocation(660,200);
    setTitle("Ausgabe der Daten");

    // setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setGUI();
  } // create


  void setGUI() {
    Editor= new JTextArea("");
    JScrollPane Sc;

    Editor.setFont( new Font("Courier New", Font.BOLD,24));
    Editor.setText("-");
    Sc = new JScrollPane(Editor);
    getContentPane().add( Sc, BorderLayout.CENTER);
    readListe();

  }  // setGUI


  private void readListe() {
    FileInputStream Fin;
    MyDataInputStream Din;
    File file;
    long i, Anz, MatrNr;
    String sEdit="";
    String sName, sVorname, sStdgang;
    Fin = null;
    try {
      file = new File(_sFilename);  // Existiert die Datei
      if (file.exists() ) {
        try {
            // Oeffnen der Datei
          Fin = new FileInputStream(_sFilename);
          Din = new MyDataInputStream(Fin);
            // Datei wird bis zum Schluss gelesen
            // Abbruch durch Exception!!!
            // Deshal finally-Anweisung mit Close
          while (true) {
            sName = Din.readString();
            sVorname = Din.readString();
            MatrNr = Din.readLong();
            sStdgang = Din.readString();
            sEdit = sEdit + sName+", "+sVorname+"  "+MatrNr+"  "+sStdgang+"\n";
          }  // while
        }
        catch (IOException e2) {
        }
      	finally {
           if (Fin != null) {
            Fin.close();
            Editor.setText(sEdit);
           }
           else
             Editor.setText("Fehler beim lesen");
	      }
      }
      else {
        Editor.setText("Datei nicht vorhanden");
      }
     }
     catch (IOException ee) {
        System.err.println("IOException: " + ee);
    }
  }


}  // window_liste




// Klasse zum Speichern der Studentendaten
class Database {
  String _sFilename;

  public Database(String sFilename) {
    _sFilename =sFilename;
  }

  public void addStudent(  String sVorname, String sNachname,
            long Matrnr, String sStudiengang) {
    int i, Anz;
    FileOutputStream Fout;
    MyDataOutputStream Dout;
    File file;

    try {
      file = new File(_sFilename);
          // Parameter:  Filename, bAppend
      if (file.exists() )
        Fout = new FileOutputStream(_sFilename, true);
      else
        Fout = new FileOutputStream(_sFilename);
      Dout = new MyDataOutputStream(Fout);
      Dout.writeString(sVorname);
      Dout.writeString(sNachname);
      Dout.writeLong(Matrnr);
      Dout.writeString(sStudiengang);
      Fout.close();
     }
     catch (IOException ee) {
        System.err.println("IOException: " + ee);
    }
 }  // addStudent

}  // Database



/**
 * description: Erweitert die Klasse DataInputStream um die Methode readString
 * @see ExtendedDataInputStream.writeString()
 *
 * @version     1.0  07.07.2002
 * @author Michael Wilhelm HS Harz, FB AI
 */
class MyDataInputStream extends DataInputStream {

	/**
	 * Konstruiert ein neues ExtendedDataInputStream Objekt.
	 *
	 * @param in Der InputStream aus dem gelesen wird
	 */
	public MyDataInputStream(InputStream in){
		super(in);
	}

	/**
	 * Liest eine Anzahl Zeichen aus dem Stream und gibt diese
	 * als String zurck.
	 *
	 * @return Das String-Objekt, welches die gelesenen Zeichen enthlt
	 * @throws IOException
	 */
	public String readString() throws IOException {
		int n = readInt();
		//System.out.println("Number of characters:" + n);
		String s = new String("");
		for(int i = 0; i < n; i++){
			s += readChar();
		}
	   return s;
	}

}  // Ende MyDataInputStream



// Die beiden folgenden Klassen erweitern die
// Klasse DataInputStream bzw. DataOutputStream
// um die Methode des Lesen bzw. Schreibens eines Strings
class MyDataOutputStream extends DataOutputStream {

	/**
	 * Konstruiert ein neues ExtendedDataOutputStream Objekt.
	 *
	 * @param out Der OutputStream in den geschrieben wird..
	 */
	public MyDataOutputStream(OutputStream out) {
		super(out);  // Aufruf des Kontruktors der Oberklasse
	}

	/**
	 * Schreibt einen String in den Stream.
	 *
	 * @param s Der zu schreibende String
	 * @throws IOException
	 */
  // Erst wird die Anzahl der Characters geschrieben
  // Danach die einzelnen Zeichen
	public void writeString(String s) throws IOException{
		int n = s.length();
		//System.out.println("String:" + s);
		//System.out.println("StringNumber of characters:" + n);
		writeInt(n);
		for(int i= 0; i < n; i++)
			writeChar(s.charAt(i));
	}


}  // Ende MyDataOutputStream


